#!/bin/bash
# cat /userdata/bringup_test_result
# cat /userdata/bringup_test_log | grep -e No -e fail -e err

BRINGUP_TEST_RESULT="/userdata/bringup_test_result"
rm ${BRINGUP_TEST_RESULT} 2> /dev/null

function execmd {
    local cmd="$@"
    echo "cmd: ${cmd}"
    bash -c "${cmd}" && echo "success: $(date +%F-%T): ${cmd}" >> ${BRINGUP_TEST_RESULT} || echo "failed: $(date +%F-%T): ${cmd}" >> ${BRINGUP_TEST_RESULT} &
}

function 4h_fun {
    execmd "cat /proc/version && cat /proc/cmdline"
    execmd "/app/testcase/S17_SOC_System/S17E02_CPU/script/cpu.sh"
    execmd "memtester 50M 1"
    execmd "dd if=/dev/zero of=/userdata/mmc_test.bin bs=1M count=512"
    execmd "ping 10.106.32.23 -c 3"
}
function 4h_press {
    execmd "cat /proc/version && cat /proc/cmdline"
    execmd "/app/testcase/S17_SOC_System/S17E02_CPU/script/cpu_press.sh"
    execmd "memtester 1G 440"
    execmd "iozone -a -O -f /userdata/mmc_test.bin -Rb /userdata/mmc_output.xls"
    execmd "iperf3 -c 192.168.32.23 -b 700M -t 7200"
}


function 12h_codec_fun {
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecTest.test_encoding_case_h265_3840x2160_420p --test_md5=0   &&\
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecTest.test_encoding_case_h264_3840x2160_420p --test_md5=0   &&\
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecTest.test_encoding_case_h265_1920x1080_420p --test_md5=0   &&\
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecTest.test_encoding_case_h264_1920x1080_420p --test_md5=0   &&\
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecJpegTest.test_encoding_case_jpeg_nv12 --pic_width=3840 --pic_height=2160 --test_md5=0   &&\
    /app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecJpegTest.test_encoding_case_jpeg_nv12 --pic_width=1920 --pic_height=1088 --test_md5=0
}
function 12h_fun {
    4h_fun
    12h_codec_fun && echo "success: $(date +%F-%T): 12h_codec_fun" >> ${BRINGUP_TEST_RESULT} || echo "failed: $(date +%F-%T): 12h_codec_fun" >> ${BRINGUP_TEST_RESULT} &
    execmd "echo /usr/lib/firmware > /sys/module/firmware_class/parameters/path && sleep 1 && /app/testcase/S04_BPU/bin/test_bpu_api"
    execmd "dd if=/dev/sda of=/dev/null bs=1M count=32"
}
function 12h_press {
    4h_press
    execmd "echo /usr/lib/firmware > /sys/module/firmware_class/parameters/path && sleep 1 && cd /app/testcase/S04_BPU/testsuite/res/s100_model_verify && ./stress_test.sh"
    execmd "/app/testcase/S07_Codec/bin/multimedia_test --gtest_filter=MediaCodecTest.test_stability_multi_encoding_case --test_time=7200 --test_thread=7 --pic_width=3840 --pic_height=2160 --test_md5=0 --test_framerate=25 --test_rcmode=5"
}


function 19h_gps_sc_fun {
    stty -F /dev/ttyS1 speed 38400
    timeout 5 cat /dev/ttyS1 > /tmp/19h_gps_sc_fun
    if [ $(cat /tmp/19h_gps_sc_fun | wc -l) -lt 1 ]; then
        return 1
    fi
    return 0
}
function 19h_fun {
    12h_fun
    19h_gps_sc_fun && echo "success: $(date +%F-%T): 19h_gps_sc_fun" >> ${BRINGUP_TEST_RESULT} || echo "failed: $(date +%F-%T): 19h_gps_sc_fun" >> ${BRINGUP_TEST_RESULT} &
    execmd "hwclock"
    execmd "/app/sample/S83_Sample/S83E02_Communication/vehicleio_sample/vehicleio/init_chassis_recv.sh 30 && /app/testcase/S21_Runtime/S21E08/S21E08C01_Virtual_CAN/testsuit/canhal_test.sh 30"
    execmd "/app/testcase/S16_Peripheral/S16E03_SPI/testsuite/imu_test.sh && /app/sample/S83_Sample/S83E01_SensorAccess/imu_sample/bin/imu_sample /dev/spidev0.0 asm330"
    execmd "dd if=/dev/mtd0 of=/tmp/mtd0_offset_48m bs=2M skip=24 count=1 && dd if=/tmp/mtd0_offset_48m of=/dev/mtd0 bs=2M seek=24 count=1"
    execmd "sleep 2 && /app/testcase/S83_Sample/S83E10_Timesync/testsuit/timesync_sample1.sh"
    execmd "/app/testcase/S09_VPS/testsuite/scripts/BU_super_scenario_test_case.sh BU_FPGA_Scenario_7V_cpe01_sen_cim01_isp01_pym01_show"
}
function 19h_press {
    12h_press
    execmd "/app/testcase/S16_Peripheral/S16E03_SPI/testsuite/imu_test.sh && /app/sample/S83_Sample/S83E06_Tros/sc_camera_sample/sensor_center/init_loc.sh"
    execmd "sleep 2 && export LOGLEVEL=15 && /app/sample/S83_Sample/S83E10_Timesync/timesync_sample/bin/timesync_sample -s 1 -w 1000000 > /log/timesync1.log"
    execmd "/app/testcase/S09_VPS/testsuite/scripts/BU_super_scenario_test_case.sh BU_FPGA_Scenario_7V_cpe01_sen_cim01_isp01_pym01_show -r=21600"
}


function usage() {
	echo "Usage: bringup_test.sh <test_type>"
	echo "  test_type: 4h_fun, 4h_press, 12h_fun, 12h_press, 19h_fun, 19h_press"
    echo "example0: bringup_test.sh 4h_fun &"
    echo "example1: save test log: bringup_test.sh 4h_fun &> /userdata/bringup_test_log &"
    echo "see result: cat ${BRINGUP_TEST_RESULT}"
}

function main() {
	if [ -z "$1" ]; then
		echo "No test type parameter provided!"
		usage
		exit 1
	fi

    echo "bringup test $1 start"
    echo "bringup test $1 start. $(date +%F-%T)" >> ${BRINGUP_TEST_RESULT}

	case "$1" in
	4h_fun)
		4h_fun
		;;
	4h_press)
		4h_press
		;;
	12h_fun)
		12h_fun
		;;
	12h_press)
		12h_press
		;;
	19h_fun)
		19h_fun
		;;
	19h_press)
		19h_press
		;;
	*)
		usage
		exit 1
		;;
	esac

    sleep 5
    echo "=====================Preview=========================="
    cat ${BRINGUP_TEST_RESULT}
    echo "======================================================"
    wait
	echo "bringup test $1 end"
    echo "bringup test $1 end. $(date +%F-%T)" >> ${BRINGUP_TEST_RESULT}
    echo "see result in ${BRINGUP_TEST_RESULT}"
    echo "======================Result=========================="
    cat ${BRINGUP_TEST_RESULT}
    echo "======================================================"
}

main "$1"
exit 0
