#!/bin/bash
echo "System resumed at $(date)" >> /var/log/system-resume.log

### clear the boot count ###
dd if=/usr/hobot/share/ota/aonreg_write_cmd of=/dev/block/platform/by-name/flashcmd bs=256k &

### record reset reason ###
hobot-log record_reset_reason &

cat /sys/class/boardinfo/bootdevice_name | grep -q scsi || {
        echo "start eMMC training..."
        ### trigger a read action for emmc resume ###
        blkid /dev/mmcblk0 > /dev/null
        echo 999 > /sys/kernel/debug/mmc0/phy/training
}

### GPU resume workaround ###
reload_gpu_modules()
{
        modprobe mali_gpu_power
        modprobe mali_gpu_system
        modprobe mali_gpu_assign ptm_config='A:S0:P0:W0'
        modprobe mali_gpu_partition_config
        modprobe mali_gpu_partition_control
        modprobe mali_arbiter
        modprobe mali_gpu_resource_group
        echo "0x1" > /sys/bus/platform/devices/260a0000.gpu_resource_group/arbiter/partitions/partition0/active_slices
        echo "0x1" > /sys/bus/platform/devices/260a0000.gpu_resource_group/arbiter/partitions/partition0/assigned_access_windows
        modprobe mali_gpu_aw
        modprobe mali_kbase
}

reload_gpu_modules

# restore gdm when wake up
systemctl restart gdm
