#!/bin/bash
echo "System suspend at $(date)" >> /var/log/system-suspend.log

### GPU suspend workaround ###
rmmod_gpu_modules()
{
        rmmod mali_kbase
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_kbase failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_aw
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_aw failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_resource_group
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_resource_group failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_arbiter
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_arbiter failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_partition_control
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_partition_control failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_partition_config
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_partition_config failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_assign
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_assign failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_system
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_system failed" >> /var/log/system-suspend.log
                return 1
        fi

        rmmod mali_gpu_power
        if [ $? -ne 0 ]
        then
                echo "rmmod mali_gpu_power failed" >> /var/log/system-suspend.log
                return 1
        fi

}

sleep_mcu1()
{
        mcu1_state=$(cat /sys/class/remoteproc/remoteproc_mcu0/state)
        suspend_mode=$(cat /sys/devices/platform/suspend-mode/suspend_mode/current_suspend_mode)

        if [ "${mcu1_state}" = "running" ] && [ "${suspend_mode}" = "deep" ]; then
                echo sleep > /sys/class/remoteproc/remoteproc_mcu0/state
                echo "mcu1 sleep" >> /var/log/system-suspend.log
        fi
}

# close gdm service befor sleep, it will block sleep
systemctl stop gdm

rmmod_gpu_modules

sleep_mcu1
